
public class MergeSort<T extends Comparable<? super T>> implements SortInterface<T> {

	@Override
	public void sort(T[] arrayToSort) {
		Object[] tempArray = new Object[arrayToSort.length];
		mergeSort(arrayToSort, tempArray, 0, arrayToSort.length - 1);
	}

	private void mergeSort(T[] array, Object[] temp, int first, int last) {
		if (first < last) {
			int mid = (first + last) / 2;
			mergeSort(array, temp, first, mid);
			mergeSort(array, temp, mid+1, last);
			merge(array, temp, first, mid, last);
		}
	}
	
	private void merge(T[] array, Object[] temp, int first, int mid, int last) {
		int firstLeft = first;
		int lastLeft = mid;
		int firstRight = mid + 1;
		int lastRight = last;
		
		int index = firstLeft;
		while ((firstLeft <= lastLeft) && (firstRight <= lastRight)) {
			if (array[firstLeft].compareTo(array[firstRight]) < 0) {
				temp[index++] = array[firstLeft++];
			} else {
				temp[index++] = array[firstRight++];
			}
		}
  
		while (firstLeft <= lastLeft) {
			temp[index++] = array[firstLeft++];
		}
		
		while (firstRight <= lastRight) {
			temp[index++] = array[firstRight++];
		}
		
		for ( index = first ; index <= last ; index++ ) {
			array[index] = (T) temp[index];
		}
		
		
		for ( int i = 0 ; i < array.length ; i++ ) {
			System.out.print(array[i] + ", ");
		}
		System.out.println();
		
	}
}
